/**
 * CopyRight (C) 2005 Bam Rescue Simulation Team.All rights resserved.
 *
 * Hamid Mohammadi <hmohammadi110@gmail.com>
 * Hamed Shahbazi  <demahopilot@yahoo.com>
 * Behrooz Shahgholi <shahgholi@eng.ui.ac.ir>
 *
 */

package yab.agent;
import java.util.*;
import yab.agent.object.*;
import yab.io.ObjectElement;

public class DisasterSpace {

    public static int count=0;
    private final HashMap m_idObjMap = new HashMap();
    public final RealObject self;

    public final ArrayList roads     = new ArrayList();
    public final ArrayList nodes     = new ArrayList();
    public final ArrayList buildings = new ArrayList();
    public final ArrayList refuges   = new ArrayList();
    public final ArrayList humanoids = new ArrayList();
    public final ArrayList civilians = new ArrayList();
    public final ArrayList ambulanceTeams = new ArrayList();
    public final ArrayList fireBrigades   = new ArrayList();
    public final ArrayList policeForces   = new ArrayList();
    public ArrayList nearHumanoid= new ArrayList();
    public ArrayList nearPolice=new ArrayList();

    public DisasterSpace(int selfId, ObjectElement[] objs) {
        update(objs, Constants.TIME_INITIALIZING_AGENT);
        self = get(selfId);
        m_maxX=0;
        m_maxY=0;
        m_minX=Integer.MAX_VALUE;
        m_minY=Integer.MAX_VALUE;
    }

    private int  m_time;
    private long m_minX;
    private long m_minY;
    private long m_maxX;
    private long m_maxY;
    public int  time() { return m_time; }
    public long maxX() { return m_maxX; }
    public long maxY() { return m_maxY; }
    public long minX() { return m_minX; }
    public long minY() { return m_minY; }

    public void add(RealObject obj) {
        m_idObjMap.put(new Integer(obj.id), obj);
        if      (obj instanceof Road)     {
          roads.add(obj);
        }
        else if (obj instanceof Node)     nodes    .add(obj);
        else if (obj instanceof Building) {
            buildings.add(obj);
            if (obj instanceof Refuge) refuges.add(obj);
        }
        else if (obj instanceof Humanoid) {
            humanoids.add(obj);
            if      (obj instanceof Civilian)      civilians.add(obj);
            else if (obj instanceof AmbulanceTeam) ambulanceTeams.add(obj);
            else if (obj instanceof FireBrigade)   fireBrigades.add(obj);
            else if (obj instanceof PoliceForce)   policeForces.add(obj);
        }
    }

    public RealObject get(int id) {
        return (RealObject) m_idObjMap.get(new Integer(id));
    }

   public void setRoadMax(){
         //System.out.println("here1");
         for(Iterator it=roads.iterator();it.hasNext();){
            Road roadTemp = (Road) it.next();
            if (m_maxX < roadTemp.x()) m_maxX = roadTemp.x();
            if (m_maxY < roadTemp.y()) m_maxY = roadTemp.y();
            if (m_minX > roadTemp.x()) m_minX = roadTemp.x();
            if (m_minY > roadTemp.y()) m_minY = roadTemp.y();
          }

   }

   public void setNeighbor(){
     for (Iterator it1 = buildings.iterator(); it1.hasNext(); )
     {
       Building tempBuilding = (Building) it1.next();
       for (Iterator it2 = buildings.iterator(); it2.hasNext(); )
       {
         Building tempBuilding2 = (Building) it2.next();
         if (tempBuilding.distance(tempBuilding2) <= 30000)
                   tempBuilding.neighborBuildingwithoutE.add((RealObject)tempBuilding2);
         if(tempBuilding.distance(tempBuilding2)<=60000)
                   tempBuilding.nearBuildings.add((RealObject) tempBuilding2);

       }

       tempBuilding.neighborBuilding.addAll(tempBuilding.neighborBuildingwithoutE);
       tempBuilding.neighborBuilding.addAll(tempBuilding.neighborhood());


     }
   }

   public void updateBlockByAnother(RealObject real){

      RCRObject obj=get(real.id);
      ((Road) obj).obj().setBlock(0);
   }

   public void update(ObjectElement[] objs, int time)  {
       m_time = time;
       nearHumanoid.clear();
       nearPolice.clear();

       if(time==4 && self instanceof FireBrigade)
         setNeighbor();
       if(time==3 && self instanceof AmbulanceTeam)
          setRoadMax();

        for (int i = 0;  i < objs.length;  i ++) {

            RCRObject obj = get(objs[i].id);

            if (obj == null) {
               obj = RCRObject.produce(objs[i].type, objs[i].id, this);

               if (obj instanceof RealObject){
                   add((RealObject) obj);

               }

             }
              if(obj instanceof Humanoid)
                 nearHumanoid.add(obj);
              if(obj instanceof PoliceForce)
                  nearPolice.add(obj);
            obj.setTime(time);
            obj.setProperty(objs[i].properties);

        }
    }
}
