// Copyright (C) 2002 Takeshi Morimoto <morimoto@takopen.cs.uec.ac.jp>
// All rights reserved.

/**
 * CopyRight (C) 2005 Bam Rescue Simulation Team.All rights resserved.
 *
 * Hamid Mohammadi <hmohammadi110@gmail.com>
 * Hamed Shahbazi  <demahopilot@yahoo.com>
 * Behrooz Shahgholi <shahgholi@eng.ui.ac.ir>
 *
 */

package yab.agent.object;

import java.util.*;
import yab.agent.DisasterSpace;
import yab.io.object.*;
import java.math.*;

public class Building extends PointObject {
    public Building(int id, BaseBuilding object, DisasterSpace world) {
        super(id, object, world);
    }

    public Building(int id, DisasterSpace world) {
        super(id, new BaseBuilding(id), world);
    }

    private BaseBuilding obj() {
        return (BaseBuilding) object;
    }

    public ArrayList neighborBuilding = new ArrayList();
    public ArrayList neighborBuildingwithoutE = new ArrayList();
    public ArrayList nearBuildings = new ArrayList();
    public ArrayList neighborBuilding() {
        return neighborBuilding;
    }

    public ArrayList neighborBuildingwithoutE() {
        return neighborBuildingwithoutE;
    }

    public ArrayList liveCivilians = new ArrayList();


    public boolean hCiv = false;

    public boolean havecivilian() {
        return hCiv;
    }

    public int safeNeighbor() {
        int sumArea = 0;
        int flag = 0;
        for (Iterator it = nearBuildings.iterator(); it.hasNext(); ) {
            Building temp = (Building) it.next();
            if (temp.fieryness() == 0) {
                sumArea += (temp.buildingAreaTotal()) -
                        1000 * ((temp.buildingCode() + 1) % 3);
                flag += 1;
            }

        }
        if (flag == 0) {
            return 0;
        }
        sumArea = (sumArea - (int) 1.5 * (buildingAreaTotal()) -
                   55000 * fieryness());
        return sumArea;
    }


    public int floors() {
        return obj().floors();
    }

    public int fieryness() {
        return obj().fieryness();
    }

    public int buildingCode() {
        return obj().buildingCode();
    }

    public int buildingAreaGround() {
        return obj().buildingAreaGround();
    }

    public int buildingAreaTotal() {
        return obj().buildingAreaTotal();
    }

    private MotionlessObject m_entrance = null;
    public MotionlessObject entrance() {
        if (m_entrance == null) {
            m_entrance = (MotionlessObject) world.get(obj().entrance());
        }
        return m_entrance;
    }

    private Set m_entrances = null;
    public Collection neighborhood() {
        if (m_entrances == null) {
            m_entrances = Collections.singleton(entrance());
        }
        return m_entrances;
    }

    public boolean isUnburned() {
        return fieryness() == 0;
    }

    public boolean isBurning() {
        return 1 <= fieryness() && fieryness() <= 3;
    }

    public boolean isPutOut() {
        return 5 <= fieryness() && fieryness() <= 7;
    }

    /** CAUTION: This method is implemented assuming that the agent
     *  can perceive all fires in the disaster space regardless of how
     *  far them are.
     */
    public int burningTime() {
        return world.time() - m_ignitedTime;
    }

    private int m_ignitedTime = Integer.MAX_VALUE;

    public void setProperty(int type, int[] value) {
        boolean wasUnburned = fieryness() == 0;
        super.setProperty(type, value);
        if (wasUnburned && fieryness() != 0) {
            m_ignitedTime = world.time();
        }
    }
}
