// Copyright (C) 2002 Takeshi Morimoto <morimoto@takopen.cs.uec.ac.jp>
// All rights reserved.

/**
 * CopyRight (C) 2005 Bam Rescue Simulation Team.All rights resserved.
 *
 * Hamid Mohammadi <hmohammadi110@gmail.com>
 * Hamed Shahbazi  <demahopilot@yahoo.com>
 * Behrooz Shahgholi <shahgholi@eng.ui.ac.ir>
 *
 */

package yab.agent.object;

import yab.agent.*;
import yab.io.object.*;

public class Road extends Edge {
    public Road(int id, DisasterSpace world) {
        super(id, new BaseRoad(id), world);
    }

    public BaseRoad obj() {
        return (BaseRoad) object;
    }

    public int width() {
        return obj().width();
    }

    public int block() {
        return obj().block();
    }

    public void setBlock(int block) {
        obj().setBlock(block);
    }

    public int repairCost() {
        return obj().repairCost();
    }

    public int linesToHead() {
        return obj().linesToHead();
    }

    public int linesToTail() {
        return obj().linesToTail();
    }

    private float lineWidth() {
        return ((float) width()) / ((float) linesToHead() + linesToTail());
    }

    private int blockedLines() {
        return (int) Math.floor(block() / (2f * lineWidth()) + 0.5f);
    }

    public int passableLinesToHead() {
        return Util.max(0, linesToHead() - blockedLines());
    }

    public int passableLinesToTail() {
        return Util.max(0, linesToTail() - blockedLines());
    }

    public int passableLinesTo(PointObject to) {
        return to == head() ? passableLinesToHead() : passableLinesToTail();
    }

    public int passableLinesFrom(PointObject from) {
        return from == tail() ? passableLinesToHead() : passableLinesToTail();
    }

    public int passableLines() {
        return Util.min(passableLinesToHead(), passableLinesToTail());
    }

    public int directiontotail;
    public void incEngagedToHead(int inc) {
        obj().incEngagedToHead(inc);
    }

    public void resetEngagedToHead() {
        obj().resetEngagedToHead();
    }

    public int getEngagedToHead() {
        return obj().getEngagedToHead();
    }

    public void incEngagedToTail(int inc) {
        obj().incEngagedToTail(inc);
    }

    public void resetEngagedToTail() {
        obj().resetEngagedToTail();
    }

    public int getEngagedToTail() {
        return obj().getEngagedToTail();
    }
}
