// Copyright (C) 2002 Takeshi Morimoto <morimoto@takopen.cs.uec.ac.jp>
// All rights reserved.

/**
 * CopyRight (C) 2005 Bam Rescue Simulation Team.All rights resserved.
 *
 * Hamid Mohammadi <hmohammadi110@gmail.com>
 * Hamed Shahbazi  <demahopilot@yahoo.com>
 * Behrooz Shahgholi <shahgholi@eng.ui.ac.ir>
 *
 */

package yab.io;

public interface ProtocolConstants {
    /** @see "<code>port</code> of the RUN/config.txt" */
    static final int KERNEL_LISTENING_PORT = 7000;
    static final int KERNEL_LISTENING_PORT_OLD = 6000;
    static final int KERNEL_LISTENING_PORT_UDP = 8000;

    /** @see "<code>send_udp_size</code> of the RUN/config.txt" */
    static final int UDP_PACKET_SIZE = 1472; //[byte]

    /** @see "<code>System::agentConnect()</code> of the kernel/System.cxx" */
    static final String REASON_OF_KA_CONNECT_ERROR = "no more agent";

    static final int
            HEADER_NULL = 0x00,
                          AK_CONNECT = 0x10,
                                       AK_ACKNOWLEDGE = 0x11,
            AK_REST = 0x80,
                      AK_MOVE = 0x81,
                                AK_LOAD = 0x82,
                                          AK_UNLOAD = 0x83,
            AK_SAY = 0x84,
                     AK_TELL = 0x85,
                               AK_EXTINGUISH = 0x86,
                                               AK_STRETCH = 0x87,
            AK_RESCUE = 0x88,
                        AK_CLEAR = 0x89,
                                   KA_CONNECT_OK = 0x50,
            KA_CONNECT_ERROR = 0x51,
                               KA_SENSE = 0x52,
                                          KA_HEAR = 0x53,
            KA_HEAR_TELL = 0x54,
                           KA_HEAR_SAY = 0x55;

    static final int
            TYPE_NULL = 0,
                        TYPE_ROAD = 168,
                                    TYPE_RIVER = 169,
                                                 TYPE_BUILDING = 176,
            TYPE_REFUGE = 184,
                          TYPE_FIRE_STATION = 185,
                                              TYPE_AMBULANCE_CENTER = 186,
            TYPE_POLICE_OFFICE = 187,
                                 TYPE_RIVER_NODE = 201,
            TYPE_NODE = 200,
                        TYPE_WORLD = 208,
                                     TYPE_CIVILIAN = 232,
            TYPE_FIRE_BRIGADE = 233,
                                TYPE_FIRE_COMPANY = TYPE_FIRE_BRIGADE,
            TYPE_AMBULANCE_TEAM = 234,
                                  TYPE_POLICE_FORCE = 235,
            TYPE_CAR = 236;

    static final int
            PROPERTY_NULL = 0,
                            PROPERTY_WIDTH = 38,
                                             PROPERTY_BUILDING_AREA_TOTAL = 52,
            PROPERTY_START_TIME = 29,
                                  PROPERTY_SIGNAL_TIMING = 130,
            PROPERTY_LINES_TO_HEAD = 41,
                                     PROPERTY_POSITION_HISTORY = 207,
            PROPERTY_CARS_PASS_TO_HEAD = 34,
                                         PROPERTY_LATITUDE = 31,
            PROPERTY_DIRECTION = 27,
                                 PROPERTY_BLOCK = 22,
                                                  PROPERTY_STAMINA = 9,
            PROPERTY_HEAD = 12,
                            PROPERTY_EDGES = 242,
                                             PROPERTY_BUILDING_CODE = 50,
            PROPERTY_SIGNAL = 44,
                              PROPERTY_FIERYNESS = 16,
            PROPERTY_WIND_DIRECTION = 33,
                                      PROPERTY_LENGTH = 24,
            PROPERTY_FLOORS = 14,
                              PROPERTY_HUMANS_PASS_TO_TAIL = 37,
            PROPERTY_ROAD_KIND = 19,
                                 PROPERTY_REPAIR_COST = 39,
            PROPERTY_IGNITION = 48,
                                PROPERTY_BUILDING_AREA_GROUND = 51,
            PROPERTY_BROKENNESS = 17,
                                  PROPERTY_WIND_FORCE = 32,
            PROPERTY_SHORTCUT_TO_TURN = 128,
                                        PROPERTY_WIDTH_FOR_WALKERS = 43,
            PROPERTY_MEDIAN_STRIP = 40,
                                    PROPERTY_Y = 4,
                                                 PROPERTY_ENTRANCES = 235,
            PROPERTY_X = 3,
                         PROPERTY_POSITION = 6,
                                             PROPERTY_POSITION_EXTRA = 7,
            PROPERTY_WATER_QUANTITY = 25,
                                      PROPERTY_LONGITUDE = 30,
            PROPERTY_STRETCHED_LENGTH = 26,
                                        PROPERTY_HUMANS_PASS_TO_HEAD = 36,
            PROPERTY_BURIEDNESS = 23,
                                  PROPERTY_LINES_TO_TAIL = 42,
            PROPERTY_HP = 10,
                          PROPERTY_BUILDING_APEXES = 131,
            PROPERTY_DAMAGE = 11,
                              PROPERTY_CARS_PASS_TO_TAIL = 35,
            PROPERTY_BUILDING_ATTRIBUTES = 15,
                                           PROPERTY_POCKET_TO_TURN_ACROSS = 129,
            PROPERTY_TAIL = 13;

    static final int
            AGENT_TYPE_CIVILIAN = 1,
                                  AGENT_TYPE_FIRE_BRIGADE = 2,
            AGENT_TYPE_FIRE_STATION = 4,
                                      AGENT_TYPE_AMBULANCE_TEAM = 8,
            AGENT_TYPE_AMBULANCE_CENTER = 16,
                                          AGENT_TYPE_POLICE_FORCE = 32,
            AGENT_TYPE_POLICE_OFFICE = 64;
}
