// Copyright (C) 2002 Takeshi Morimoto <morimoto@takopen.cs.uec.ac.jp>
// All rights reserved.

/**
 * CopyRight (C) 2005 Bam Rescue Simulation Team.All rights resserved.
 *
 * Hamid Mohammadi <hmohammadi110@gmail.com>
 * Hamed Shahbazi  <demahopilot@yahoo.com>
 * Behrooz Shahgholi <shahgholi@eng.ui.ac.ir>
 *
 */

package bam;

import java.net.*;
import yab.agent.*;
import yab.agent.object.*;

public class FireStationAgent extends AbstractFireStationAgent {
    private int MaxLengthMessage;
    private String messageBuffer;

    public FireStationAgent(InetAddress address, int port) {
        super(address, port);
        MaxLengthMessage = 256;
        messageBuffer = new String("!");
       }

    /*Sending all messages that saved into messagebuffer*/
    private void sendBufferData() {
        if (messageBuffer.length() > 1) {
            tell(messageBuffer);
            messageBuffer = null;
            messageBuffer = "!";
        }
    }


    public void act() throws ActionCommandException {
        if (world.time() > 5 || world.time() % 3 == 1) {
            sendBufferData();
        }
        rest();
    }

    protected void hear(RealObject sender, String message) {

        if (sender instanceof PoliceOffice || sender instanceof AmbulanceCenter || sender instanceof FireStation) {
            return;
        } else
        if (sender instanceof FireBrigade) {
            if ((message.length() + messageBuffer.length() + 1) >=
                MaxLengthMessage) {
                tell(messageBuffer);
                messageBuffer = null;
                messageBuffer = "!";
            }

            if (messageBuffer.length() > 0) {
                messageBuffer = messageBuffer.concat("*");
            }
            messageBuffer = messageBuffer.concat(message);
        }
    }
}
