// Copyright (C) 2002 Takeshi Morimoto <morimoto@takopen.cs.uec.ac.jp>
// All rights reserved.

package yab.agent;

import java.net.*;
import java.util.*;
import yab.agent.*;
import yab.agent.object.*;

public abstract class HumanoidAgent extends Agent {
    protected HumanoidAgent(int agentType, InetAddress address, int port) {
        super(agentType, address, port);
    }

    private Humanoid self() { return (Humanoid) world.self; }
    private long  priviousEnd;
    private int lastTime;
    public  int[] lastRoute=new int[100];
    protected int hearingLimit() { return HEARING_LIMIT_OF_HUMANOID; }

    protected boolean move(MotionlessObject destination)
        throws ActionCommandException {
        return move(Collections.singleton(destination));
    }
    protected boolean move(Collection destinations) throws ActionCommandException{
        Route route=getRoute(destinations);
       // System.out.println("route cost: "+route.cost+  "           route end:"+route.end.id);
        return  move(route);
    }
    //000000000000000000000000000000000000000000000000000000000000000000000000000000
    protected boolean move(Route routePlan) throws ActionCommandException {
                
     /*  if(lastRoute.length!=0 &&  self().motionlessPosition() instanceof Road &&
                ( (Road) self().motionlessPosition()).passableLines()!=0 && 
                (routePlan.toIDs()[routePlan.size()-1])==priviousEnd && world.time()==lastTime+1) return false; 
        */
         //lastRoute=routePlan.toIDs();
         ///priviousEnd=routePlan.toIDs()[routePlan.toIDs().length-1];
         //lastTime=world.time();
         
         move(routePlan.toIDs());
        
         return true;
        
    }
    
    protected void move(int[] routePlan) throws ActionCommandException {
         for(int i=0;i<routePlan.length-1;i++) 
         {
           MotionlessObject former=(MotionlessObject)world.get(routePlan[i]);
           MotionlessObject later=(MotionlessObject)world.get(routePlan[i+1]);
           if(former instanceof Road && later instanceof Node)
           {
               if(((Node)later).equals(((Road)former).head()))
                   ((Road)former).directiontotail=0;
               else                    
                   ((Road)former).directiontotail=1;
           }
         }
         
         socket().akMove(self().id, routePlan);   
         throw new ActionCommandException();
         
    }
    
    public int[] getLast()
    {
        return lastRoute;
    }
  
  
    protected Route getRoute(Collection destinations) {
        MotionlessObject pos = self().motionlessPosition();
        if (!(pos instanceof Road)  ||  ((Road) pos).passableLines() >= 1)
            return Router.get(pos, destinations, RELIABILITY_COST_FUNCTION);
        Route route = Router.get(outsidePosition(), destinations,
                                 RELIABILITY_COST_FUNCTION);
        modifyOriginToCurrentPosition(route);
        return route;
    }
    public MotionlessObject outsidePosition() {
        Road rd = (Road) self().motionlessPosition();
        return ( (self().positionExtra() < rd.length() / 2 ) )
            ? rd.head() : rd.tail();
    }
    public void modifyOriginToCurrentPosition(Route route) {
        MotionlessObject pos = self().motionlessPosition();
        for (Route rt = route;  true;  rt = rt.previous()) {
            if (rt.end == pos) {
                rt.setPrevious(null);
                return;
            }
            if (rt.previous() == null) {
                rt.setPrevious(new Route(pos));
                return;
            }
        }
    }
    private static final Router.CostFunction RELIABILITY_COST_FUNCTION
      = new Router.CostFunction() {
     public float cost(MotionlessObject from, MotionlessObject to,int distance) {
                    final int WEIGHT = 10000;
                    float Cost=0.0f;

                   /*if (from instanceof PointObject )
                    {
                      Collection near_road= from.neighborhood();

                      for (Iterator j=near_road.iterator();j.hasNext();)
                      {

                          MotionlessObject edge=(MotionlessObject) j.next();
                          if (edge instanceof Road)
                          {
                              Road rd=(Road) edge ;

                              if (to instanceof PointObject)
                              {
                                 
                                if (rd.neighborhood().contains(to) )
                                 {
                                   System.out.println("omad inja");
                                  Cost=rd.length()/1000;

                                    if(from==(MotionlessObject)rd.tail()&&
                                                     rd.passableLinesToHead()<1)
                                       Cost=Cost+WEIGHT*WEIGHT*WEIGHT;
                                    if(from==(MotionlessObject)rd.head()&&
                                                     rd.passableLinesToTail()<1)
                                       Cost=Cost+WEIGHT*WEIGHT*WEIGHT;

                                    return Cost;
                                }
                              }
                              else
                              {
                                 if (rd==(Road)to)
                                  if(from==(MotionlessObject)rd.tail()&&
                                                     rd.passableLinesToHead()<1)
                                       Cost=Cost+WEIGHT*WEIGHT*WEIGHT;
                                   if(from==(MotionlessObject)rd.head()&&
                                                     rd.passableLinesToTail()<1)
                                       Cost=Cost+WEIGHT*WEIGHT*WEIGHT;
                                    return Cost;
                              }
                          }// is not road
                          else if (edge instanceof PointObject)
                              return Cost;
                          else                              return Integer.MAX_VALUE*Integer.MAX_VALUE;
                      }

                    }
                   else
                   {
                       Road from1=(Road)from;
                       if (to instanceof PointObject)
                           {
                               if (from1.neighborhood().contains(to) )
                                 {

                                  Cost=from1.length()/1000;
                                    if(to==from1.tail()&&
                                                     from1.passableLinesToTail()<1)
                                       Cost=Cost+WEIGHT*WEIGHT*WEIGHT/distance1;
                                    if(to==from1.head()&&
                                                     from1.passableLinesToHead()<1)
                                       Cost=Cost+WEIGHT*WEIGHT*WEIGHT/distance1;
                                    return Cost;
                                }
                             }
                              else
                              {
                                 if(from==to)
                                 {
                                     Road from2=(Road) from;
                                     if( from2.passableLines() <1)
                                       return Integer.MAX_VALUE*Integer.MAX_VALUE;
                                     else return Integer.MAX_VALUE;
                                 }
                                 else return Integer.MAX_VALUE*Integer.MAX_VALUE;
                              }

                   }
                    return Cost;*/
                    
                   if (from instanceof PointObject )
                    {
                      if(to instanceof PointObject && from.neighborhood().contains(to))
                      {
                           return 0;
                      }
                      else if(to instanceof Road  && from.neighborhood().contains(to))
                      {
                          Road tempRd=(Road)to;
                          Cost=tempRd.length()/10;
                          if(from==(MotionlessObject)tempRd.tail() && tempRd.passableLinesToHead()<1)
                               Cost=Cost+tempRd.getEngagedToHead()*WEIGHT;
                          if(from==(MotionlessObject)tempRd.head() && tempRd.passableLinesToTail()<1)
                               Cost=Cost+tempRd.getEngagedToTail()*WEIGHT;
                          return Cost;
                      }
                      else return Integer .MAX_VALUE*Integer.MAX_VALUE;
                    }
                   else
                   {
                       Road from1=(Road)from;
                       if (to instanceof PointObject)
                           {
                               if (from1.neighborhood().contains(to) )
                                 {

                                  Cost=from1.length()/10;
                                    if(to==from1.tail()&&
                                                     from1.passableLinesToTail()<1)
                                       Cost=Cost+from1.getEngagedToTail()*WEIGHT;
                                    if(to==from1.head()&&
                                                     from1.passableLinesToHead()<1)
                                       Cost=Cost+from1.getEngagedToHead()*WEIGHT;
                                    return Cost;
                               }
                           }
                              
                   }
                    return Cost;
                  

                   }
    }; 

}
