// Copyright (C) 2002 Takeshi Morimoto <morimoto@takopen.cs.uec.ac.jp>
// All rights reserved.
package yab.agent.object;
import java.util.*;
import yab.agent.DisasterSpace;
import yab.io.object.*;
import java.math.*;
public class Building extends PointObject {

    public Building(int id, BaseBuilding object, DisasterSpace world){
        super(id, object, world);
    }

    public Building(int id, DisasterSpace world){
        super(id, new BaseBuilding(id), world);
    }

    private BaseBuilding obj() {
        return (BaseBuilding) object;
    }
    public ArrayList neighborBuilding=new ArrayList();
    public ArrayList nearBuildings=new ArrayList();
    public ArrayList civilians=new ArrayList();
    public ArrayList neighborBuildingwithoutE=new ArrayList();

    public ArrayList neighborBuilding(){
        return neighborBuilding;
    }

    public ArrayList neighborBuildingwithoutE(){
        return neighborBuildingwithoutE;
    }

    protected static final Property
        BURIEDNESS_PRP   = Property.get("Humanoid", "buriedness"),
        FIERYNESS_PRP    = Property.get("Building", "fieryness"),
        HP_PRP           = Property.get("Humanoid", "hp");

    public int safeNeighbor(){
        int sumArea=0;
        int flag=0;
        for(Iterator it=nearBuildings.iterator();it.hasNext();){
            Building temp=(Building) it.next();
            if(temp.fieryness()==0){
               sumArea +=(temp.buildingAreaTotal())-1000* ((temp.buildingCode()+1)%3)+1000*temp.civilians.size();
               flag+=1;
            }
        }
        if(flag==0) return 0;
        sumArea = (sumArea-(int)1.5*(buildingAreaTotal())+5500*fieryness())+1000*civilians.size()+10000* ((buildingCode()+1)%3);
        return sumArea;
    }

    public void setNewCivilian(Humanoid civ){
        civilians.add(civ);
    }

    public long areaneihborsafe(){
        long Area=0;

        for(Iterator it=nearBuildings.iterator();it.hasNext();){
            Building temp=(Building)it.next();
            if(temp.isUnburned())
                Area += temp.buildingAreaTotal();
        }
        return Area;
    }

    public long areaneihborburned(){
        long Area=0;
        for(Iterator it=nearBuildings.iterator();it.hasNext();){
            Building temp=(Building)it.next();
            if(!temp.isUnburned())
                Area += temp.buildingAreaTotal();
        }
        return Area;
    }

    public float buildingcodeaverage(){
        float average=0;
        float number=0;
        for(Iterator it=nearBuildings.iterator();it.hasNext();) {
            Building temp=(Building)it.next();
            if(temp.isUnburned()){
                average +=10*temp.buildingCode();
                number++;
            }
        }
        return ((float)(average/number));
    }

    public int priority(){
        int relativearea=0;
        int selfcode=0;
        int neihborcode=0;
        int fiery=0;
        int priority=1;

        if(fieryness()>1 && fieryness()<4)
            fiery=1;
        else
            fiery=2;

        if(buildingCode()==2)
            selfcode=1;
        else
            selfcode=2;

        if(buildingcodeaverage()<=10)
            neihborcode=1;
        else
            neihborcode=2;

        float relative=0;
        float differ=0;
        relative=(float)areaneihborsafe()/buildingAreaGround();
        if(areaneihborsafe()==0)
            return 0;
        //differ=areaneihborsafe()-areaneihborburned();
        //if(differ<0)
        //return 1;
        //differ=(float)differ/buildingAreaTotal();
        //relative=differ;

        if(relative>=19)
            relativearea=1;
        else if(relative>=9)
            relativearea=2;
        else if(relative>=4)
            relativearea=3;
        else if(relative>=0)
            relativearea=4;

        priority=fiery*1000+selfcode*100+neihborcode*10+relativearea;

        switch(priority){
            case 1111: priority=32; break;
            case 1112: priority=28; break;
            case 1113: priority=22; break;
            case 1114: priority=13; break;
            case 1121: priority=30; break;
            case 1122: priority=26; break;
            case 1123: priority=15; break;
            case 1124: priority=12; break;
            case 1211: priority=24; break;
            case 1212: priority=17; break;
            case 1213: priority=8;  break;
            case 1214: priority=4;  break;
            case 1221: priority=23; break;
            case 1222: priority=16; break;
            case 1223: priority=7;  break;
            case 1224: priority=3;  break;
            case 2111: priority=31; break;
            case 2112: priority=27; break;
            case 2113: priority=21; break;
            case 2114: priority=10; break;
            case 2121: priority=29; break;
            case 2122: priority=25; break;
            case 2123: priority=19; break;
            case 2124: priority=9;  break;
            case 2211: priority=20; break;
            case 2212: priority=14; break;
            case 2213: priority=6;  break;
            case 2214: priority=2;  break;
            case 2221: priority=18; break;
            case 2222: priority=11; break;
            case 2223: priority=5;  break;
            case 2224: priority=1;  break;
            //default: priority=0;
        }
        int neighborCivilianSize=civilians.size();
        for(Iterator neighborItr=neighborBuildingwithoutE.iterator();neighborItr.hasNext();)
            neighborCivilianSize=neighborCivilianSize+((Building)neighborItr.next()).civilians.size();
        //if(relative>0)
        //System.out.println("             civilian size: "+neighborCivilianSize);
        priority=priority+3*neighborCivilianSize;
      //  priority+=safeNeighbor();

        return priority;
    }

    public int floors()             { return obj().floors(); }
    public int fieryness()          { return obj().fieryness(); }
    public int buildingCode()       { return obj().buildingCode(); }
    public int buildingAreaGround() { return obj().buildingAreaGround(); }
    public int buildingAreaTotal()  { return obj().buildingAreaTotal(); }
    private MotionlessObject m_entrance = null;
    public MotionlessObject entrance() {
        if (m_entrance == null)
            m_entrance = (MotionlessObject) world.get(obj().entrance());
        return m_entrance;
    }

    private Set m_entrances = null;
    public Collection neighborhood() {
        if (m_entrances == null)
            m_entrances = Collections.singleton(entrance());
        return m_entrances;
    }
    public int dangerNeighbor() {
        int sumArea=0;
        int flag=0;
        for(Iterator it=nearBuildings.iterator();it.hasNext();) {
            Building temp=(Building) it.next();
            if(temp.fieryness()==0){
                ArrayList hmn_brd=BURIEDNESS_PRP.gt(0).and(HP_PRP.gt(0)).extract(temp.world.civilians);
                sumArea+=200000000*hmn_brd.size();
            }
        }
        return sumArea;
    }
    public boolean isUnburned() { return fieryness() == 0; }
    public boolean isBurning() { return 1 <= fieryness() && fieryness() <= 3; }
    public boolean isPutOut() { return 5 <= fieryness() && fieryness() <= 7; }

    /** CAUTION: This method is implemented assuming that the agent
     *  can perceive all fires in the disaster space regardless of how
     *  far them are.
     */
    public int burningTime() { return world.time() - m_ignitedTime ; }
   /* public int Priority() {
     if(fieryness()>3 || fieryness()==0) return 0;
     return  (1000/(burningTime()*burningTime()+10*(buildingCode()+1)+(buildingAreaTotal()/100)+2*fieryness()*fieryness()));
    }*/
    private int m_ignitedTime = Integer.MAX_VALUE;

    public void setProperty(int type, int[] value) {
        boolean wasUnburned = fieryness() == 0;
        super.setProperty(type, value);
        if (wasUnburned  &&  fieryness() != 0)
            m_ignitedTime = world.time();
    }
}
