package yab.io;

import java.io.*;
import java.net.*;

public class TCPSocket implements ProtocolConstants {
    private InetAddress m_address;//address of kernel
    private int m_port;//port of kernel
    private Socket m_socket;//socket for connecting
    private short m_sendingId = 0;//ID?
    private DataInputStream inStream;//inout Stream for getting data from socket

   //Constructor of TCP Socket
    public TCPSocket(InetAddress kernelAddress, int kernelPort) {
        try {
            m_address = kernelAddress;
            m_port    = kernelPort;
            m_socket  = new Socket(m_address, m_port);
        } catch (Exception e) { throw new Error(e); }
    }

    //Recieve Method
    public byte[] receive()
        {

                byte[] buf = new byte[4];
                byte[] message;

                try{

                        DataInputStream inStream = new DataInputStream(m_socket.getInputStream());
                        int received;
                        int total = 0;
                        int length = inStream.readInt();
                        total = 0;
                        message = new byte[length];
                       inStream.readFully(message);
                        return message;
        } catch (Exception e) {
            if(e.getMessage() =="Connection reset")
            {
                System.out.println("End of Simulating...\n Connection Reset from Kernel");
                System.exit(1);
            }


            throw new Error(e);
        }
        }

    //Send Method
    public void send(byte[] data)
        {
                final int length = data.length;

                try{
                        DataOutputStream outStream = new DataOutputStream(m_socket.getOutputStream());
                        outStream.writeInt(length);
                        outStream.write(data,0,length);
                        return;
                } catch (Exception e) { throw new Error(e); }
        }


}

