/**
 * CopyRight (C) 2005 Bam Rescue Simulation Team.All rights resserved.
 *
 * Hamid Mohammadi <hmohammadi110@gmail.com>
 * Hamed Shahbazi  <demahopilot@yahoo.com>
 * Behrooz Shahgholi <shahgholi@eng.ui.ac.ir>
 *
 */


package bam;

import java.net.*;
import java.util.*;
import yab.agent.*;
import yab.agent.object.*;

public class PoliceForceAgent extends AbstractPoliceForceAgent {
    class hmns {
        public int priority;
        public Humanoid hmn;
    }


    public ArrayList randomRoad = new ArrayList();
    private ArrayList deadArray = new ArrayList();

    protected int zone;
    protected int numberOfZone;
    protected int firstZone;
    protected int firstNumberOfZone;
    protected long maxX;
    protected long maxY;
    protected long minX;
    protected long minY;
    private boolean hearZone;

    private ArrayList m_reportedBlockades = new ArrayList();
    private ArrayList m_reportedBlockadesMain = new ArrayList();

    protected static final Condition HAS_NOT_BEEN_SEEN_CND
            = Property.get("RealObject", "hasBeenSeen").equal(Boolean.FALSE);

    ArrayList tempList = new ArrayList();
    ArrayList brdReports = new ArrayList();

    protected static final Property
            FIERYNESS_PRP = Property.get("Building", "fieryness");
    protected static final Condition
            IS_BURNING_CND = FIERYNESS_PRP.gte(1).and(FIERYNESS_PRP.lte(3));

    private int flag = 0;
    public PoliceForceAgent(InetAddress address, int port) {
        super(address, port);
        zone = 1;
        numberOfZone = 1;
        maxX = Integer.MAX_VALUE;
        maxY = Integer.MAX_VALUE;
        minX = 0;
        minY = 0;
        randomRoad.addAll(world.roads);
        hearZone = false;
        searchBuildings = new ArrayList(world.buildings);
    }

    protected boolean inMyZone(RealObject road) {

        return (road.x() >= minX && road.x() <= maxX && road.y() <= maxY &&
                road.y() >= minY);
    }

    protected void gotoZone() throws ActionCommandException {
        for (Iterator it = world.roads.iterator(); it.hasNext(); ) {
            Road tempRoad = (Road) it.next();
            if (inMyZone(tempRoad)) {
                m_reportedBlockades.add((RealObject) tempRoad);
                moveReportedBlockades(m_reportedBlockades);
                return;
            }
        }
    }


    protected void setZone() {
        int numberOfColumn = numberOfZone / 2 + numberOfZone % 2;
        int column = (zone <= numberOfColumn) ? zone : zone - numberOfColumn;
        int row = (zone > numberOfColumn) ? 1 : 0;
        if (row == 1 && numberOfZone % 2 == 1) {
            numberOfColumn = numberOfColumn - 1;
        }
        maxY = (row == 0) ?
               world.minY() + ((world.maxY() - world.minY()) / 2) + 800 :
               world.maxY();
        maxX = world.minX() +
               (column * (world.maxX() - world.minX()) / numberOfColumn) + 650;
        minX = world.minX() +
               ((column - 1) * (world.maxX() - world.minX()) / numberOfColumn) -
               650;
        minY = (row == 0) ? world.minY() :
               world.minY() + ((world.maxY() - world.minY()) / 2) - 800;
    }


    protected void reportHumanoid() {
        int maxprio = 100;
        if (!world.nearHumanoid.isEmpty()) {
            for (Iterator it = world.nearHumanoid.iterator(); it.hasNext(); ) {
                Humanoid tempHumanoid;
                tempHumanoid = (Humanoid) it.next();
                if ((tempHumanoid instanceof Civilian) && tempHumanoid.hp() > 0) {
                    tell("c " + tempHumanoid.hp() + " " + tempHumanoid.damage() +
                         " " +
                         tempHumanoid.buriedness() + " " + tempHumanoid.id +
                         " " +
                         tempHumanoid.motionlessPosition().id);
                } else {
                    if (tempHumanoid != null &&
                        !deadArray.contains(tempHumanoid)) {
                        deadArray.add(tempHumanoid);
                        tell("die " + tempHumanoid.id);
                    }

                }
            }
            recordHuman bestHuman = new recordHuman();
            bestHuman.hp = ((Humanoid) world.nearHumanoid.get(0)).hp();
            bestHuman.damage = ((Humanoid) world.nearHumanoid.get(0)).damage();
            bestHuman.buridness = ((Humanoid) world.nearHumanoid.get(0)).
                                  buriedness();
            bestHuman.time = ((Humanoid) world.nearHumanoid.get(0)).time();
            bestHuman.self = (Humanoid) world.nearHumanoid.get(0);
            bestHuman.mlpos = ((Humanoid) world.nearHumanoid.get(0)).
                              motionlessPosition();
            maxprio = bestHuman.priority(world.time(),
                                         world.ambulanceTeams.size());
            Humanoid deadHuman = null;
            Iterator itr = world.nearHumanoid.iterator();
            itr.next();
            recordHuman bestHuman1 = new recordHuman();
            for (; itr.hasNext(); ) {
                Humanoid temp = (Humanoid) itr.next();
                if (temp.hp() == 0) {
                    deadHuman = temp;
                }
                int tempAmbulanceSize = 1;
                if (world.ambulanceTeams.size() > 1) {
                    tempAmbulanceSize = world.ambulanceTeams.size();
                }
                int futureHp = temp.hp() -
                               (temp.buriedness() * temp.damage() /
                                (tempAmbulanceSize));
                if (temp.buriedness() > 0 && futureHp > 0 &&
                    !(brdReports.contains(temp))) {
                    bestHuman1.hp = temp.hp();
                    bestHuman1.damage = temp.damage();
                    bestHuman1.buridness = temp.buriedness();
                    bestHuman1.time = temp.time();
                    bestHuman1.mlpos = temp.motionlessPosition();
                    bestHuman1.self = temp;
                    if (bestHuman1.priority(world.time(),
                                            world.ambulanceTeams.size()) <
                        maxprio && bestHuman1.mlpos() != null) {
                        bestHuman = bestHuman1;
                        maxprio = bestHuman1.priority(world.time(),
                                world.ambulanceTeams.size());
                    }
                }
            }
            int tempAmbulanceSize = 1;
            if (world.ambulanceTeams.size() > 1) {
                tempAmbulanceSize = world.ambulanceTeams.size();
            }
            int futureHp = bestHuman.hp -
                           bestHuman.buridness * bestHuman.damage /
                           (tempAmbulanceSize);
            if (bestHuman.buridness > 0 && futureHp > 0 && bestHuman != null &&
                bestHuman.mlpos() != null) {
                if (!brdReports.contains(bestHuman.self)) {
                    brdReports.add(bestHuman.self);
                    tell("c " + bestHuman.hp + " " + bestHuman.damage + " " +
                         bestHuman.buridness + " " + bestHuman.self.id + " " +
                         bestHuman.mlpos().id);
                }
            }
            if (deadHuman != null && !deadArray.contains(deadHuman)) {
                deadArray.add(deadHuman);
                tell("die " + deadHuman.id);
            }
        }

    }

    int oldPosition = 0;
    protected void act() throws ActionCommandException {
        if (self().buriedness() > 0 && time() > 5) {
            tell("pfh " + self().hp() + " " + self().damage() + " " +
                 self().buriedness() + " " + self().id + " " +
                 self().motionlessPosition().id);
        }

        if (world.time() % 15 == 0) {
            brdReports.clear();
        }
        clearHere();
        if (time() % 3 == 2 & self().motionlessPosition().id == oldPosition) {
            ArrayList others = new ArrayList();
            others.addAll(world.roads);
            others.remove(self().motionlessPosition());
            if (others != null && !others.isEmpty()) {
                move(others);
            }
        }

        if (time() >= 4 && flag == 0) {
            tellZone();
            flag = 1;
        }

        if (hearZone || time() > 20) {
            reportHumanoid();
        }

        if (time() % 3 == 0 && (self().motionlessPosition() instanceof Road)) {
            oldPosition = self().motionlessPosition().id;
        }
        if (self().damage() > 0) {
            move(world.refuges);
        }
        if (!m_reportedBlockadesMain.isEmpty()) {
            moveReportedBlockades(m_reportedBlockadesMain);
        }
        if (!inMyZone(self())) {
            gotoZone();
        }
        if (!m_reportedBlockades.isEmpty()) {
            moveReportedBlockades(m_reportedBlockades);
        }
        searchBlockades();
        randomMove();
        move(world.refuges);
    }

    protected void clearHere() throws ActionCommandException {
        MotionlessObject pos = self().motionlessPosition();
        if (!(pos instanceof Road)) {
            return;
        }
        Road road = (Road) pos;
        if (road.passableLines() == 0) {
            clear(road);
        }
    }

    public void tellZone() {
        int temp = whichZone(world.policeForces.size(), self());
        tell("zoneNow: " + self().id + " " + temp);
    }

    public int whichZone(int numberOfZoneIn, RealObject real) {
        int numberOfColumn;
        int column;
        int row;
        long maxYTemp;
        long maxXTemp;
        long minXTemp;
        long minYTemp;
        PoliceForce policeTemp = (PoliceForce) world.get(real.id);
        for (int counter = 0; counter < world.policeForces.size(); counter++) {
            numberOfColumn = numberOfZoneIn / 2 + numberOfZoneIn % 2;
            column = (counter <= numberOfColumn) ? counter :
                     counter - numberOfColumn;
            row = (counter > numberOfColumn) ? 1 : 0;
            if (row == 1 && numberOfZoneIn % 2 == 1) {
                numberOfColumn = numberOfColumn - 1;
            }
            maxYTemp = (row == 0) ?
                       world.minY() + ((world.maxY() - world.minY()) / 2) + 800 :
                       world.maxY();
            maxXTemp = world.minX() +
                       (column * (world.maxX() - world.minX()) / numberOfColumn) +
                       650;
            minXTemp = world.minX() +
                       ((column - 1) * (world.maxX() - world.minX()) /
                        numberOfColumn) - 650;
            minYTemp = (row == 0) ? world.minY() :
                       world.minY() + ((world.maxY() - world.minY()) / 2) - 800;
            if (policeTemp.x() >= minXTemp && policeTemp.x() <= maxXTemp &&
                policeTemp.y() <= maxYTemp && policeTemp.y() >= minYTemp) {
                return (counter + 1);
            }
        }
        return 1;
    }

    protected void moveReportedBlockades(ArrayList m_reportedBlockadeTemp) throws
            ActionCommandException {
        correctReportedBlockade(m_reportedBlockadeTemp);
        if (m_reportedBlockadeTemp != null) {
            if (!m_reportedBlockadeTemp.isEmpty()) {
                move(m_reportedBlockadeTemp);
            }
        }

    }

    protected void correctReportedBlockade(ArrayList m_reportedBlockadeTemp) {
        for (Iterator it = m_reportedBlockadeTemp.iterator(); it.hasNext(); ) {
            Road road = (Road) it.next();
            if ((road.hasBeenSeen() && (road.passableLines() > 0)) ||
                (!inMyZone(road))) {
                it.remove();
            }

        }
    }

    protected void correctBuildingZone(ArrayList
                                       m_reportedBlockadeTemp) {
        for (Iterator it = m_reportedBlockadeTemp.iterator(); it.hasNext(); ) {
            Building building = (Building) it.next();
            if (!inMyZone(building)) {
                it.remove();
            }
        }
    }

    protected void correctReportedBlockadeForRandom(ArrayList
            m_reportedBlockadeTemp) {
        for (Iterator it = m_reportedBlockadeTemp.iterator(); it.hasNext(); ) {
            Road road = (Road) it.next();
            if (!inMyZone(road)) {
                it.remove();
            }
        }
    }

    protected void searchBlockades() throws ActionCommandException {
        List uncheckedRoads = HAS_NOT_BEEN_SEEN_CND.extract(world.roads);
        for (Iterator it = uncheckedRoads.iterator(); it.hasNext(); ) {
            Road road = (Road) it.next();
            if (!inMyZone(road)) {
                it.remove();
            }
        }
        if (!uncheckedRoads.isEmpty()) {
            if (zone == 7 && numberOfZone == 11 && time() > 16) {
                for (Iterator it = uncheckedRoads.iterator(); it.hasNext(); ) {
                    Road roadTemp = (Road) it.next();

                }
            }

            if (uncheckedRoads != null && !uncheckedRoads.isEmpty()) {
                move(uncheckedRoads);
            }
        } else {
            if (numberOfZone >= 4) {
                if (numberOfZone == world.policeForces.size()) {
                    ackClearZone(numberOfZone, zone);
                }
                numberOfZone = (numberOfZone + 1) / 2 + numberOfZone % 2;
                zone = zone / 2 + zone % 2;
                setZone();
            } else {
                zone = firstZone;
                numberOfZone = firstNumberOfZone;
            }
        }
    }

    protected void ackClearZone(int numberOfZoneIn, int zoneIn) {
        if (numberOfZone == world.policeForces.size()) {

            tell("clearZone: " + numberOfZone + " " + zone);
        }
    }


    public ArrayList randompoint = new ArrayList();
    public int randtime = 0;
    ArrayList searchBuildings = new ArrayList();

    public void randomMove() throws ActionCommandException {
        if (!randompoint.isEmpty()) {
            if (self().motionlessPosition().equals((MotionlessObject)
                    randompoint.get(0)) || (time() - randtime) > 4) {
                randompoint.clear();
            } else {
                move(randompoint);
            }
        }
        if (!searchBuildings.isEmpty()) {
            if (time() <= 10) {
                randompoint.clear();
            }
            Building randmChoice = (Building) searchBuildings.remove(0);
            if (randmChoice.isUnburned()) {
                randompoint.add(randmChoice);
                randtime = time();
                move(randompoint);
            }

        }
    }


    protected void correctZone(int numberOfZoneIn, int zoneIn) {
        int numberOfColumn = numberOfZoneIn / 2 + numberOfZoneIn % 2;
        int column = (zoneIn <= numberOfColumn) ? zoneIn :
                     zoneIn - numberOfColumn;

        int row = (zoneIn > numberOfColumn) ? 1 : 0;
        if (row == 1 && numberOfZoneIn % 2 == 1) {
            numberOfColumn = numberOfColumn - 1;
        }
        long maxYTemp = (row == 0) ?
                        world.minY() + ((world.maxY() - world.minY()) / 2) +
                        800 : world.maxY();
        long maxXTemp = world.minX() +
                        (column * (world.maxX() - world.minX()) /
                         numberOfColumn) +
                        650;
        long minXTemp = world.minX() +
                        ((column - 1) * (world.maxX() - world.minX()) /
                         numberOfColumn) - 650;
        long minYTemp = (row == 0) ? world.minY() :
                        world.minY() + ((world.maxY() - world.minY()) / 2) -
                        800;
        Iterator itr1 = world.roads.iterator();
        Road road = (Road) world.roads.iterator().next();
        for (itr1 = world.roads.iterator(); itr1.hasNext(); ) {
            road = (Road) itr1.next();
            if (road.x() >= minXTemp && road.x() <= maxXTemp &&
                road.y() <= maxYTemp && road.y() >= minYTemp) {
                world.updateByAnother(road);
            }

        }
    }

    protected void hear(RealObject sender, String message) {

        StringTokenizer stFirst = new StringTokenizer(message, "*");
        for (; stFirst.hasMoreTokens(); ) {
            String messageTemp = stFirst.nextToken();
            StringTokenizer st = new StringTokenizer(messageTemp);
            String command = st.nextToken();
            if (command.equals("clr")) {
                RealObject target = world.get(Integer.parseInt(st.nextToken()));
                m_reportedBlockades.add(target);
            }

            if (command.equals("clearZone:")) {
                int numberOfZoneIn = Integer.parseInt(st.nextToken());
                int zoneIn = Integer.parseInt(st.nextToken());
                correctZone(numberOfZoneIn, zoneIn);
            }

            if (command.equals("nmv")) {
                MotionlessObject target = (MotionlessObject) world.get(Integer.
                        parseInt(st.nextToken()));
                if (!m_reportedBlockadesMain.contains(target)) {
                    m_reportedBlockadesMain.add(target);
                }

            }
            if (command.equals("c")) {
                if (st.hasMoreTokens()) {
                    st.nextToken();
                }
                if (st.hasMoreTokens()) {
                    st.nextToken();
                }
                if (st.hasMoreTokens()) {
                    st.nextToken();
                }
                Humanoid reportedOthersHuman = (Humanoid) world.get(Integer.
                        parseInt(st.nextToken()));
                if (!brdReports.contains(reportedOthersHuman)) {
                    brdReports.add(reportedOthersHuman);
                }
            }
            if (command.equals("Zone:")) {
                hearZone = true;
                numberOfZone = Integer.parseInt(st.nextToken());
                firstNumberOfZone = numberOfZone;
                correctBuildingZone(searchBuildings);
                StringTokenizer st1;
                for (; st.hasMoreTokens(); ) {
                    String zone = st.nextToken();
                    st1 = new StringTokenizer(zone, "/");
                    int idTemp = Integer.parseInt(st1.nextToken());
                    int numberTemp = Integer.parseInt(st1.nextToken());
                    if (self().hashCode() == idTemp) {
                        this.zone = numberTemp;
                        firstZone = numberTemp;
                        setZone();
                        break;
                    }

                }
                correctReportedBlockadeForRandom(randomRoad);
            }

        }
    }

}
