// Copyright (C) 2002 Takeshi Morimoto <morimoto@takopen.cs.uec.ac.jp>
// All rights reserved.
package yab.agent;
import java.util.*;
import java.net.*;
import yab.agent.*;
import yab.agent.object.*;
import yab.io.ProtocolConstants;

public abstract class AbstractPoliceForceAgent extends PlatoonAgent {
    protected AbstractPoliceForceAgent(InetAddress address, int port) {
        super(ProtocolConstants.AGENT_TYPE_POLICE_FORCE, address, port);
    }
    protected PoliceForce self() { return (PoliceForce) world.self; }

    protected void clear(Road target) throws ActionCommandException {
        socket().akClear(self().id, target.id);
        throw new ActionCommandException();
    }
   protected void moveN(MotionlessObject destination)
        throws ActionCommandException {
         moveN(Collections.singleton(destination));
    }
    protected void moveN(Collection destinations) throws ActionCommandException{
          move(getRoute1(destinations));
    }
     protected Route getRoute1(Collection destinations) {

        MotionlessObject pos = self().motionlessPosition();
        if (!(pos instanceof Road)  ||  ((Road) pos).passableLines() >= 1)
            return Router.get(pos, destinations, RELIABILITY_COST_FUNCTION1);
        Route route = Router.get(outsidePosition(), destinations,
                                 RELIABILITY_COST_FUNCTION1);
        modifyOriginToCurrentPosition(route);
        return route;
    }
    protected Route getRoute(Collection destinations) {

        MotionlessObject pos = self().motionlessPosition();
        if (!(pos instanceof Road)  ||  ((Road) pos).passableLines() >= 1)
            return Router.get(pos, destinations, RELIABILITY_COST_FUNCTION);
        Route route = Router.get(outsidePosition(), destinations,
                                 RELIABILITY_COST_FUNCTION);
        modifyOriginToCurrentPosition(route);
        return route;
    }

     public static Router.CostFunction RELIABILITY_COST_FUNCTION = new Router.CostFunction() {
                public float cost(MotionlessObject from, MotionlessObject to) {
                    final int WEIGHT = 1000;
                    float Cost=0.0f;

                   if (from instanceof PointObject )
                    {
                      Collection near_road= from.neighborhood();

                      for (Iterator j=near_road.iterator();j.hasNext();)
                      {

                          MotionlessObject edge=(MotionlessObject) j.next();
                          if (edge instanceof Road)
                          {
                              Road rd=(Road) edge ;

                              if (to instanceof PointObject)
                              {

                                if (rd.neighborhood().contains(to) )
                                 {

                                    Cost=rd.length()/1000;

                                   // return Cost;
                                }
                              }
                              else
                              {
                                 if (rd==(Road)to)
                                   Cost=0;
                                 else Cost=WEIGHT;
                              }
                          }// is not road
                          else if (edge instanceof PointObject)
                               Cost=0;
                          else
                              Cost=Integer.MAX_VALUE*Integer.MAX_VALUE;
                      }

                    }
                   else
                   {
                       Road from1=(Road)from;
                       if (to instanceof PointObject)
                           {


                                if (from1.neighborhood().contains(to) )
                                 {

                                    Cost=from1.length()/1000;
          }

                             }
                              else
                              {
                                 if(from==to)
                                   Cost=0;

                                 else Cost= Integer.MAX_VALUE*Integer.MAX_VALUE;
                              }

                   }

  return Cost;
  }
};


   private static final Router.CostFunction RELIABILITY_COST_FUNCTION1
      = new Router.CostFunction() {
     public float cost(MotionlessObject from, MotionlessObject to) {
                    final int WEIGHT = 1000;
                    float Cost=0.0f;

                   if (from instanceof PointObject )
                    {
                      Collection near_road= from.neighborhood();

                      for (Iterator j=near_road.iterator();j.hasNext();)
                      {

                          MotionlessObject edge=(MotionlessObject) j.next();
                          if (edge instanceof Road)
                          {
                              Road rd=(Road) edge ;

                              if (to instanceof PointObject)
                              {
                                if (rd.neighborhood().contains(to) )
                                 {

                                  Cost=rd.length()/1000;

                                    if(from==(MotionlessObject)rd.tail()&&
                                                     rd.passableLinesToHead()<1)
                                       Cost=Cost+WEIGHT*WEIGHT;
                                    if(from==(MotionlessObject)rd.head()&&
                                                     rd.passableLinesToTail()<1)
                                       Cost=Cost+WEIGHT*WEIGHT;

                                    return Cost;
                                }
                              }
                              else
                              {
                                 if (rd==(Road)to)
                                  if(from==(MotionlessObject)rd.tail()&&
                                                     rd.passableLinesToHead()<1)
                                       Cost=Cost+WEIGHT*WEIGHT;
                                   if(from==(MotionlessObject)rd.head()&&
                                                     rd.passableLinesToTail()<1)
                                       Cost=Cost+WEIGHT*WEIGHT;
                                    return Cost;
                              }
                          }// is not road
                          else if (edge instanceof PointObject)
                              return Cost;
                          else
                              return Integer.MAX_VALUE*Integer.MAX_VALUE;
                      }

                    }
                   else
                   {
                       Road from1=(Road)from;
                       if (to instanceof PointObject)
                           {
                               if (from1.neighborhood().contains(to) )
                                 {

                                  Cost=from1.length()/1000;
                                    if(to==from1.tail()&&
                                                     from1.passableLinesToTail()<1)
                                       Cost=Cost+WEIGHT*WEIGHT;
                                    if(to==from1.head()&&
                                                     from1.passableLinesToHead()<1)
                                       Cost=Cost+WEIGHT*WEIGHT;
                                    return Cost;
                                }
                             }
                              else
                              {
                                 if(from==to)
                                 {
                                     Road from2=(Road) from;
                                     if( from2.passableLines() <1)
                                             return Integer.MAX_VALUE*Integer.MAX_VALUE;
                                     else return Integer.MAX_VALUE;
                                 }
                                 else return Integer.MAX_VALUE*Integer.MAX_VALUE;
                              }

                   }
                    return Cost;
                   }
    };
}

